/* A header file used by the TM ports package */

#define TM_MAX_PACKET_DATA	16383
#define TM_MAX_PORTS		256

#define TM_PACKET_HLEN		4

struct tm_packet {
	int h;		/* Really int_32 */
	char data[TM_MAX_PACKET_DATA];
	};

#define TM_PACKET_WRITE(p)	(((p).h & 0x80000000) != 0)
#define TM_PACKET_NEEDS_ACK(p)	(((p).h & 0x40000000) != 0)
#define TM_PACKET_CHIP(p)	(((p).h & 0x30000000) >> 28)
#define TM_PACKET_PORT(p)	(((p).h & 0x03FC0000) >> 18)
#define TM_PACKET_PORT_BYTES(p)	((((p).h & 0x0000F000) >> 10) | (((p).h & 0x00030000) >> 16))
#define TM_PACKET_LENGTH(p)	(((p).h & 0x00000FFF) | (((p).h & 0x0C000000) >> 14))

#define TM_SET_PACKET_WRITE(p, val)	(p).h = ((p).h & ~0x80000000) | ((val)<<31);
#define TM_SET_PACKET_NEEDS_ACK(p, val)	(p).h = ((p).h & ~0x40000000) | (((val)<<30) & 0x40000000);
#define TM_SET_PACKET_CHIP(p, val)	(p).h = ((p).h & ~0x30000000) | (((val)<<28) & 0x30000000);
#define TM_SET_PACKET_PORT(p, val)	(p).h = ((p).h & ~0x03FC0000) | (((val)<<18) & 0x03FC0000);
#define TM_SET_PACKET_PORT_BYTES(p,val) (p).h = ((p).h & ~0x0003F000) | (((val)<<10) & 0x0000F000) | (((val)<<16) & 0x00030000);;
#define TM_SET_PACKET_LENGTH(p, val)	(p).h = ((p).h & ~0x0C000FFF) | ((val) & 0x00000FFF) | (((val)<<14) & 0x0C000000);
